.TH "qubectl" 1 "February 3, 2021" "qube"
.SH NAME
qubectl \- command line tool for qube
.SH SYNOPSIS
\fBqubectl\fR \fI<module> [ <options> ]\fR
.SH DESCRIPTION
\fBqubectl\fR is the maintenance tool for qube. It uses \fImodules\fR which by itself
consists of multiple steps.
\fBqubectl\fR have to run inside the top level folder of a qube project.

.SH MODULES
\fIModule\fR could be invoked by their short or long module name.
.SS
.B B|binpkg
Create a binary distributable tar archive. To use this \fImodule\fR, it is required
that the developer(s) have provided this functionality along the qube specification.
.SS
.B C|chglog
Create a CHANGELOG file from git log.
.SS
.B N|newprj
Create a new qube project.  from a skeleton template
.SS
.B S|srcpkg
Create a tar archive to distribute the source code.
.SS
.B U|upload
upload a binary or source archive to a public place (e.g. ftp server)
.SH OPTIONS

\fIoptions\fR is a series of getopt-style options. Options depends on \fImodules\fR,
options not used by a \fImodule\fR will be ignored silently. Some \fImodules\fR may
accept more options than \fBqubectl\fR provides.

\fBqubectl\fR understands short and/or long options. The style for long options is
flexible: an argument of a long option could be seperated by a space or an equal
sign. Arguments of short options are mandantory for long options too.
.TP 8
\fI\-p|--path\fR 
Define a path to a qube toplevel directory. With \fInewprj\fR 
.TP 8
\fI\-V\fR   print versions info and exit

.SH CONFIGURATION
For each qube project a config file \fIqubepkg.conf\fR is required. This must
exist in the top level folder of each project and is required by \fBqubectl\fR.

Maintenance settings of a qube project could be configured in \fIqubectl.conf\fR.
This config file belongs to a/the specific project and must be located in the
top level directory of the related qube project. 

.SH FUTURE DIRECTIONS
None.
.SH EXAMPLE

.EX
    $> <an example>
.EE
.SH AUTHOR
<author> (©2017-QYYYY)
.SH SEE ALSO
