#********************************************************************************
# qware build environment - upload release to public location                   *
#                                                                               *
#  Author: Kai Peter, ©2019-YYYY                                                *
# Version: 0.2                                                                  *
# License: ISC                                                                  *
#                                                                               *
# Description:   *
#********************************************************************************
#---------- begin (standard) qware configuration section ------------------------
VERSION=`cat $0 | grep -m 1 'Version' | cut -d\   -f3`       # get version number
ME=`basename $0`

LOGDATE=`date +'%b %d %H:%M:%S'`
LOGFILE="QLOGDIR/${ME}.log"
DATESTR=`date +%Y%m%d`
LIBDIR="/usr/local/lib"

[ $DBG ] || DBG=0                                # set debug level (dafault: off)
CFGFILE=".qube/config"

#QUBE_MODULE_DEFAULTS  # placeholder - this line will be replaced by standard code

error() { printf "\033[1m%s\033[0m\n" "$1"; exit 1; }

help() {
  exit 0
}

#error() {
#  printf "\033[1merror: \033[0m"
#  case $1 in
#    1) echo "Invalid ssh authentication method!";;
#    2) echo "Invalid or missing argument for option '`echo $ARG | cut -d= -f1`'!";;
#    3) echo "Invalid parameter for '-p'!";;
#    6) echo "Not a qube project folder: $FLAG_P";;
#    5) echo "${FLAG_P%/}/$FLAG_NAME is a qube project already!";;
#    *) echo "unknown error!";;
#  esac
#  exit $1
#}

getTopQubeDir() {
  CURDIR=`pwd`
  until [ -d .qube ] ; do
    cd ..
    [ `pwd` = "/" ] && error "Not a qube project up to dir '/'."
    df | grep -q `pwd` && error "Not a qube project up to mountpoint `pwd`."
  done
  TOPQUBEDIR=`pwd`
}
#***** begin processing *********************************************************
getTopQubeDir            # directory where to start

CFGFILE=".qube/config"           # the config file HAVE TO exist in this location
[ ! -f "$CFGFILE" ] && error "No config file found!" || source "$CFGFILE"

SSHAUTH=`echo "$SSHAUTH" | cut -c1 | grep ^[PKpk]` || error 1

echo $SSHAUTH
exit


which sshpass &>DEVNULL || error "Error: sshpass not found, aborting!"
#[ $? -ne 0 ] && echo sshpass not found, aborting! && exit 1


#echo $TARGET
# get the ssh password to be used with sshpass
echo -n "Password: "
read -s PW
echo

# get the latest version only
for F in `ls qrtools-*.tgz | sort`; do PKG=$F ; done

echo -n Copying files ...
#sshpass -e doesn't work :(
sshpass -p $PW \
scp -P 9022 "$PKG" "$PKG.sha256" kp@conar:/home/ftp/gentoo/
[ $? -ne 0 ] && echo -e "\033[31m failed!\033[0m" || echo " ok"

echo -n Changing ownership ...
sshpass -p "$PW" ssh -p 9022 kp@conar 'cd /home/ftp/gentoo ; sudo chown ftp.ftp *'
[ $? -ne 0 ] && echo -e "\033[91m failed!\033[0m" || echo " ok"

echo Done!
